/* ************************************************************************** */
/*                                       _____           _                    */
/*  image/monochrome_packed.c           |_   _|__  _   _| |__   ___ _   _     */
/*  | Project: libg1m                     | |/ _ \| | | | '_ \ / _ \ | | |    */
/*                                        | | (_) | |_| | | | |  __/ |_| |    */
/*  By: thomas <thomas@touhey.fr>         |_|\___/ \__,_|_| |_|\___|\__, |.fr */
/*  Last updated: 2016/11/23 07:04:13                               |___/     */
/*                                                                            */
/* ************************************************************************** */
#include <libg1m/internals.h>

/**
 *	g1m_pixels_from_packed1bit:
 *	Convert packed monochrome formatted pixels to the final 32-bit matrix.
 *
 *	@arg	pixels		the final pixels.
 *	@arg	raw			the raw data.
 *	@arg	width		the width.
 *	@arg	height		the height.
 */

void g1m_pixels_from_packed1bit(uint32_t **pixels, unsigned char *raw,
	int width, int height)
{
	int byte = 128;
	for (int y = 0; y < height; y++) {
		pixels[y] = (uint32_t*)&pixels[17] + y * height;
		for (int x = 0; x < width; x++) {
			/* put pixel */
			pixels[y][x] = *raw & byte;

			/* iterate */
			raw += (byte & 1);
			byte = (byte >> 1) | ((byte & 1) << 7);
		}
	}
}
